#include <sys/stat.h>
#include <dvmbasic.h>
#include <dvmmpeg.h>
#include <dvmpnm.h>
#include <dvmcolor.h>

#define PREFIX_SIZE         100     /* prefix to the input files including directory */
#define BUFFER_SIZE         5000000   /* large enough to hold 2 frames and some headers */
#define FRAMES_PER_SECOND   25
#define FORWARD_F_CODE      3
#define WIDTH               640		//176     /* width and height of each frame in pixels */
#define HEIGHT              480		//120
#define MOV_LEN             200		// qty of frames in mpeg
#define GOP_LEN             8


typedef struct RGB_image {
	ByteImage *r;
	ByteImage *g;
	ByteImage *b;
} RGB_image;

RGB_image* RGB_init(int width, int height);
void RGB_free(RGB_image* img);

typedef struct YUV_image {
	ByteImage *y;
	ByteImage *u;
	ByteImage *v;
} YUV_image;

YUV_image* YUV_init(int width, int height);
void YUV_free(YUV_image* img);

typedef struct Sc_image {
	ScImage *scY;
	ScImage *scU;
	ScImage *scV;
        ByteImage *qScale;
        VectorImage *fmv;                       /* forward motion vector */
} Sc_image;

Sc_image* Sc_init(int w, int h);
void Sc_free(Sc_image* img);

// PROTOTYPES
int fsize (char *name);
void IncrementTime();
void Swap(YUV_image* a, YUV_image* b);
MpegSeqHdr*  MpegSeqHdrInit(int w, int h);
void mMpegGopHdrSet(MpegGopHdr *gopHdr);
void mMpegPicHdrSet(MpegPicHdr *picHdr, char frame, int temporalRef);

void mByteToScI(YUV_image* yuv, YUV_image* prev, Sc_image* scpr);
void mByteToScP(MpegPicHdr *picHdr, YUV_image* yuv, YUV_image* prev, Sc_image* scpr);
void mMpegPicPEncode(MpegPicHdr *picHdr, Sc_image* scpr, int* sliceInfo, int slieInfoLen, BitParser *obp);
void mMpegPicIEncode(MpegPicHdr *picHdr, Sc_image* scpr, int* sliceInfo, int slieInfoLen, BitParser *obp);

int pictures(void);
